{-------------------------------------------------------------}
{
{    Informaes sobre a CPU, capturadas no registry
{
{    Autor: Jose' Antonio Borges
{
{    Em 09/04/2008
{
{-------------------------------------------------------------}

unit hardcpu;

interface
uses
  dvCrt,
  dvExec,
  dvWin,
  dvForm,
  windows,
  sysutils,
  minireg,
  hardmsg;

procedure infoCPU;

implementation

procedure infoCPU;
var
    ncpu: integer;
    base: string;
    sval: array [1..18] of shortString;
    i: integer;
    s: string;

    function rget (key: string): string;
    var s: string;
    begin
        RegGetString(HKEY_LOCAL_MACHINE,
            base + '\' + key, s);
        result := s;
    end;

    function rgetDWord (key: string): Cardinal;
    var v: Cardinal;
    begin
        RegGetDWORD (HKEY_LOCAL_MACHINE,
            base + '\' + key, v);
        result := v;
    end;

   begin
    ncpu := 0;   // futuramente para processar mais de uma CPU
    base := 'HARDWARE\DESCRIPTION\System\CentralProcessor\' + chr (ncpu + ord('0'));

    garanteEspacoTela(23);
    writeln;
    tamRotulosForm := 30;
    formCria;

    sval[1] := rget ('ProcessorNameString');
    formCampo ('HVPROCES', pegaTextoMensagem('HVPROCES'), sval[1], 40);  // 'Processador'

    sval[2] := intToStr (rgetDWord ('~Mhz'));
    formCampo ('HVVELCPU', pegaTextoMensagem('HVVELCPU'), sval[2], 40);  // 'Velocidade em MHz'

    sval[3] := rget ('VendorIdentifier');
    formCampo ('HVFABCPU', pegaTextoMensagem('HVFABCPU'), sval[3], 40);  // 'Fabricante'

    sval[4] := rget ('Identifier');
    formCampo ('HVCPUID',  pegaTextoMensagem('HVCPUID'),  sval[4], 40);  // 'Identificao'

    sval[5] := intToStr (rgetDWord ('Update Status'));
    formCampo ('HVSTATAT', pegaTextoMensagem('HVSTATAT'), sval[5], 40);  // 'Status da atualizao'

    sval[6] := rget ('Identifier');
    formCampo ('HVTIPOPM', pegaTextoMensagem('HVTIPOPM'), sval[6], 40);  // 'Tipo da Placa Me'

    base := 'HARDWARE\DESCRIPTION\System';

    sval[7] := rget ('SystemBiosDate');
    formCampo ('HVDTBIOS', pegaTextoMensagem('HVDTBIOS'), sval[7], 40);  // 'Data da BIOS'

    RegGetMultiString(HKEY_LOCAL_MACHINE, base + '\SystemBiosVersion', s);
    sval[8] := s;
    for i := 1 to length (s) do if s[i] = #$0 then s[i] := '|';
    formCampo ('HVVBIOS', pegaTextoMensagem('HVVBIOS'),   sval[8], 40);  // 'Verso da BIOS'

    sval[9] := rget ('VideoBiosDate');
    formCampo ('HVDBIOSV', pegaTextoMensagem('HVDBIOSV'), sval[9], 40);  // 'Data da BIOS de vdeo'

    RegGetMultiString (HKEY_LOCAL_MACHINE, base + '\VideoBiosVersion', s);
    sval[10] := pchar(s);
    formCampo ('HVVBIOSV', pegaTextoMensagem('HVVBIOSV'), sval[10], 40);  // 'Verso da BIOS de vdeo'

    formEdita (false);
end;

end.
