{-------------------------------------------------------------}
{
{    Informaes sobre a placa me, trazida do HWMONITOR
{
{    Autor: Jose' Antonio Borges
{
{    Em 09/04/2008
{
{-------------------------------------------------------------}

unit hardmbrd;

interface
uses
  dvCrt,
  dvExec,
  dvWin,
  dvForm,
  dvMacro,
  windows,
  messages,
  classes,
  sysutils,
  hardmsg;

procedure infoPlacaMae;
procedure temperaturaEOutros;

implementation

{-------------------------------------------------------------}
{      executa o programa monitor de hardware e gera log
{-------------------------------------------------------------}

procedure execHWMonitor;
var nomeProg: string;
begin
    nomeProg := sintAmbiente ('HARDVOX', 'NOMEMONITOR');
    if nomeProg = '' then
        nomeProg := 'c:\winvox\HWMonitor.exe';
    if executaProg(nomeProg, '.', '') < 32 then
        begin
            mensagem ('HVPRONAO', 2); // 'Programa HWMonitor.exe no est disponvel'
            mensagem ('HVFUNCAN', 2); // 'Funo cancelada'
            exit;
        end
    else

    mensagem ('HVLESENS', 1); // 'Lendo sensores, aguarde'
    delay (3000);

    if FileExists('HWMONITOR.TXT') then
        deleteFile ('HWMONITOR.TXT');

    keyboardAlt ('F', 100);
    keyboardChar ('S', 100);
    keyboardString (getCurrentDir + '\HWMONITOR.TXT', 100);
    keyboardVirtKey(VK_RETURN, false, false, false, 100);
    delay (500);

    keyboardAlt ('F', 100);
    keyboardChar ('X', 100);
end;

{-------------------------------------------------------------}
{                mostra informaes da placa me
{-------------------------------------------------------------}

procedure infoPlacaMae;
var sl: TStringList;
    parseOk: boolean;
    i: integer;

    fabricante, modelo: shortstring;
    chip_monitor, fabric_chip, modelo_chip: shortstring;

begin
    execHWMonitor;
    sl := TStringList.Create;
    for i := 1 to 20 do
        begin
            if not fileExists ('HWMONITOR.TXT') then
                begin
                    delay (1000);
                    sintClek;
                end;
        end;

    delay (1000);
    if fileExists ('HWMONITOR.TXT') then
        sl.loadFromFile ('HWMONITOR.TXT')
    else
        begin
            mensagem ('HVPRONAO', 2); // 'Programa HWMonitor.exe no est disponvel'
            mensagem ('HVFUNCAN', 2); // 'Funo cancelada'
            exit;
        end;

    parseOk := false;
    for i := 0 to sl.count-1 do
        begin
            if pos ('Mainboard Vendor', sl[i]) <> 0 then
                begin
                    parseOk := true;
                    break;
                end;
        end;
    if not parseOk then
        begin
            mensagem ('HVINFNAO', 2);   //  'Informaes indisponveis'
            exit;
        end;

    fabricante    := copy (sl[i], 18, 999);
    modelo        := copy (sl[i+1], 19, 999);
    chip_monitor  := sl[i+3];
    fabric_chip   := copy (sl[i+5], 10, 999);
    modelo_chip   := copy (sl[i+6], 9, 999);

    garanteEspacoTela(23);
    writeln;
    mensagem ('HVSETFOL', 2);  // 'Use as setas para folhear'
    tamRotulosForm := 30;
    formCria;

    formCampo ('HVFABRIC', pegaTextoMensagem('HVFABRIC'), fabricante, 40);    // 'Fabricante'
    formCampo ('HVMODELO', pegaTextoMensagem('HVMODELO'), modelo, 40);        // 'Modelo'
    formCampo ('HVCHIPMN', pegaTextoMensagem('HVCHIPMN'), chip_monitor, 40);  // 'Chip monitor'
    formCampo ('HVFBCHIP', pegaTextoMensagem('HVFBCHIP'), fabric_chip, 40);   // 'Fabricante do Chip'
    formCampo ('HVMDCHIP', pegaTextoMensagem('HVMDCHIP'), modelo_chip, 40);   // 'Modelo do Chip'

    formEdita(false);

    sl.Free;
end;

{-------------------------------------------------------------}
{         mostra informaes dos circuitos de monitorao
{-------------------------------------------------------------}

procedure temperaturaEOutros;
var sl: TStringList;
    parseOk: boolean;
    inic, i, p: integer;
    sval: array [1..18] of shortString;
    s, nome, valor: string;

begin
    execHWMonitor;
    sl := TStringList.Create;
    sl.loadFromFile ('HWMONITOR.TXT');

    writeln;
    inic := 0;
    repeat
        parseOk := false;
        for i := inic to sl.count-1 do
            begin
                if pos ('Hardware monitor', sl[i]) = 1 then
                    begin
                        parseOk := true;
                        inic := i+3;
                        break;
                    end;
        end;

        if not parseOk then break;

        garanteEspacoTela(25);
        writeln;
        mensagem ('HVSETFOL', 2);  // 'Use as setas para folhear'
        tamRotulosForm := 30;
        formCria;

        sval [1] := sl[inic];
        inic := inic + 2;
        formCampo('', 'Monitor de hardware', sval[1], 40);

        i := 2;
        repeat
            s := trim (sl[inic]);
            while s[1] <> #$09 do delete (s, 1, 1);
            while s[1] = #$09 do delete (s, 1, 1);
            p := pos ('[', s);
            valor := copy (s, 1, p-2);
            delete (s, 1, pos (']', s));
            p := pos ('(', s);
            nome := copy (s, p+1, length(s)-p-1);

            s := trim (sl[inic]);
            if pos ('Temperature', s) <> 0 then
                nome := pegaTextoMensagem('HV_TEMP') + nome   // 'Temperatura '
            else
            if pos ('Voltage', s) <> 0 then
                nome := pegaTextoMensagem('HV_VOLT') + nome   // 'Voltagem '
            else
            if pos ('Fan', s) <> 0 then
                nome := pegaTextoMensagem('HV_FAN') + nome;   // 'RPM do ventilador '

            sval [i] := valor;
            formCampo('', nome, sval[i], 40);
            inic := inic + 1;
            i := i + 1;
        until sl[inic] = '';

        formEdita (false);
    until false;

    sl.Free;
end;

end.

