unit hardmem;

interface
uses
  dvCrt,
  dvExec,
  dvWin,
  dvForm,
  windows,
  sysutils,
  hardmsg;

procedure infoMemoria;

implementation


procedure campo (msg: string; var valor: shortString);
begin
    formCampo(msg, pegaTextoMensagem(msg), valor, 40);
end;

procedure infoMemoria;
var
    MemoryStatus: TMemoryStatus;
    sval: array [1..18] of shortString;

begin
    MemoryStatus.dwLength := SizeOf(MemoryStatus) ;
    GlobalMemoryStatus(MemoryStatus) ;

    garanteEspacoTela(23);
    writeln;
    tamRotulosForm := 55;
    formCria;

    with MemoryStatus do
        begin
            sval[1] := IntToStr(int64(dwTotalPhys) div (1024 * 1024));
            campo ('HVMEMFIS', sval[1]);   // 'Memria Fsica total em mb'

            sval[2] := IntToStr(int64(dwAvailPhys) div (1024 * 1024));
            campo ('HVMEMDIS', sval[2]);   // 'Memria fsica disponvel'

            sval[3] := IntToStr(dwMemoryLoad);
            campo ('HVMEMUSO', sval[3]);   // '% de memria em uso'

            sval[4] := IntToStr(int64(dwTotalPageFile) div (1024 * 1024));
            campo ('HVARQPAG', sval[4]);   // 'Tamanho do arquivo de paginao'

            sval[5] := IntToStr(int64(dwAvailPageFile) div (1024 * 1024));
            campo ('HVDISPAG', sval[5]);   // 'Disponvel no arquivo de paginao'

            sval[6] := IntToStr(int64(dwTotalVirtual) div (1024 * 1024));
            campo ('HVENDMB',  sval[6]);   // 'Espao de endereamento do usurio em mb'

            sval[7] := IntToStr(dwAvailVirtual div (1024 * 1024));
            campo ('HVENDDIS', sval[7]);   // 'Disponvel no Espao de endereamento do usurio'

            formEdita (false);
        end;
end;

end.
