{-------------------------------------------------------------}
{
{    Programa de exibio de caractersticas da mquina
{
{    Autor: Jose' Antonio Borges
{
{    Em 09/04/2008
{
{-------------------------------------------------------------}

program hardvox;

uses
  dvCrt,
  dvExec,
  dvWin,
  dvForm,
  windows,
  sysutils,
  hardmsg,
  hardhd,
  hardcpu,
  hardmoni,
  hardnome,
  hardmem,
  hardsmar,
  harduser,
  hardespd,
  hardaud,
  hardmbrd;

var versao: string = '1.0';

{-------------------------------------------------------------}
{                  inicializao
{-------------------------------------------------------------}

procedure inicializa;
var ambiente: string;
begin
    ambiente := sintAmbiente ('HARDVOX', 'DIRHARDVOX');
    if ambiente = '' then ambiente := 'c:\winvox\som\hardvox';
    sintInic (0, ambiente);

    textBackground (BLUE);
    mensagem ('HVINIC', 0);   {'Hardvox - v.'}
    sintWriteln (versao);
    textBackground (BLACK);
    writeln;
end;

{--------------------------------------------------------}
{            seleciona a opo com as setas
{--------------------------------------------------------}

function selSetasOpcao: char;

    procedure MenuAdiciona (msg: string);
    begin
         popupMenuAdiciona (msg, pegaTextoMensagem (msg));
    end;

var n: integer;
const
    nopc = 12;
    tabLetrasOpcoes: string [nopc] = 'SPTCMHEAVDU' + ESC;

begin
    garanteEspacoTela (nopc);
    popupMenuCria (wherex, wherey, 50, nopc, MAGENTA);
    MenuAdiciona ('HVOP_S');   // '  S - informaes sobre o Sistema Operacional'
    MenuAdiciona ('HVOP_P');   // '  P - placa me'
    MenuAdiciona ('HVOP_T');   // '  T - temperaturas, voltagens e outros'
    MenuAdiciona ('HVOP_C');   // '  C - CPU sob a perspectiva do Windows'
    MenuAdiciona ('HVOP_M');   // '  M - memoria RAM'
    MenuAdiciona ('HVOP_H');   // '  H - informaes fsicas sobre os HD'
    MenuAdiciona ('HVOP_E');   // '  E - espao nos discos'
    MenuAdiciona ('HVOP_A');   // '  A - udio e midi'
    MenuAdiciona ('HVOP_V');   // '  V - monitores de vdeo'
    MenuAdiciona ('HVOP_D');   // '  D - diagnostico SMART dos discos'
    MenuAdiciona ('HVOP_U');   // '  U - usurios da mquina'
    MenuAdiciona ('HVESC');    // '  ESC - termina'
    n := popupMenuSeleciona;
    if n > 0 then
        begin
            selSetasOpcao := tabLetrasOpcoes[n];
            gotoxy (20, wherey-1);
            write (tabLetrasOpcoes[n]);
            writeln;
        end
    else
        selSetasOpcao := ENTER;
end;

{-------------------------------------------------------------}
{                  loop de processamento
{-------------------------------------------------------------}

procedure processa;
var c, c2: char;
label executa;
begin
    repeat
        textBackground (BLUE);
        mensagem ('HVOPCAO', 0);    // 'Hardvox - opo: '
        textBackground (BLACK);

        sintLetecla (c, c2);
        writeln;

        if c = #0 then
            begin
                if c2 = F1 then
                    mensagem ('HVUSESET', 1)   // 'Para selecionar, use as setas'
                else
                if (c2 = CIMA) or (c2 = BAIX) then
                    begin
                        c := selSetasOpcao;
                        goto executa;
                    end
                else
                    mensagem ('HVOPINV', 1);    // 'Opo invlida: aperte F1 para ajuda'
            end
        else
            begin
executa:
                case upcase(c) of
                    'S': informacoesSistema;
                    'P': infoPlacaMae;
                    'T': temperaturaEOutros;
                    'C': infoCPU;
                    'M': infoMemoria;
                    'H': infoHD;
                    'E': mostraCaracDisco;
                    'A': infoAudio;
                    'V': infoVideo;
                    'D': monitorSmartDisco;
                    'U': infoUsuarios;
                    ESC, BS:  ;
                else
                    mensagem ('HVOPINV', 1);    // 'Opo invlida: aperte F1 para ajuda'
                end;
            end;

        writeln;
    until c = ESC;
end;

{-------------------------------------------------------------}
{                  finalizao
{-------------------------------------------------------------}

procedure termina;
begin
    mensagem ('HVOBRIG', 1);   {'Obrigado por usar o hardvox'}
    sintFim;
end;

{-------------------------------------------------------------}
{                  programa principal
{-------------------------------------------------------------}

begin
    inicializa;
    processa;
    termina;
    doneWinCrt;
end.

